new;
library qam,pgraph,optmum;

cls;
__output = 0;

let sigma = 0.15 0.10 0.05;

Sigma1 = sigma .* sigma' .* eye(3);

rho = diagrv(ones(3,3)*0.5,1);
Sigma2 = sigma .* sigma' .* rho;

let rho = 1.0
          0.5  1.0
          0.0  0.0 1.0;
rho = xpnd(rho);
Sigma3 = sigma .* sigma' .* rho;

let rho = 1.00
          0.50  1.00
          0.25  0.25  1.00;
rho = xpnd(rho);
Sigma4 = sigma .* sigma' .* rho;

A = ones(1,3); B = 1; C = 0; D = 0; Bounds = (0~1) .* ones(3,1);

i = 1;
do until i > 3;
  Results = {};
  cov = varget(itos("Sigma",i));
  {x,vol,retcode} = Qprog_Min_Variance(cov,A,B,C,D,Bounds);
  Results = Results ~ 100*(x|vol);
  {x,vol,mr,tr,rc} = Compute_ERC_Portfolio(0,cov);
  Results = Results ~ 100*(x|vol);
  {x,vol,mr,tr,rc} = Compute_MDP_Portfolio(0,cov);
  Results = Results ~ 100*(x|vol);
  print ftosa(Results,"%lf",3,2);
  i = i + 1;
endo;

cov = Sigma4;
let x = 0.20 0.30 0.50;
{vol,mr,tr,rc} = Compute_Risk_Contribution(x,cov);
Results = 100*(x~mr~tr~rc);
print ftosa(Results,"%lf",3,3);
print ftosa(100*vol,"Volatility = %lf",3,3);


