new;
library qam,pgraph,optmum;

cls;

PnL = 20 / 3 * (6.24 + 6.21 + 6.17 + 5.97 + 5.74) / 100 - 
      20 / 3 * (0.14 + 2.55 + 3.79 + 4.18 + 5.37) / 100;
print ftosa(PnL,"PnL = %lf",3,6);


let mu[10,1] =     18.23             2.45             8.95             3.48             8.98 
                    6.63             1.44             2.00            19.80             1.30;
let sigma[10,1] =  11.19            12.57            12.65             6.48             6.80 
                   11.27             4.97             4.26            11.61             4.12;
let rho[10,10] = 
            1.00             0.30             0.38             0.00             0.50             0.35             0.33             0.30             0.43             0.03 
            0.30             1.00             0.80             0.04             0.30             0.70             0.49             0.34             0.39             0.07 
            0.38             0.80             1.00             0.08             0.34             0.78             0.56             0.34             0.48             0.06 
            0.02             0.04             0.08             1.00             0.12             0.06             0.29             0.38             0.10             0.63 
            0.50             0.30             0.34             0.12             1.00             0.30             0.27             0.29             0.38             0.09 
            0.35             0.70             0.78             0.06             0.30             1.00             0.53             0.35             0.41             0.07 
            0.33             0.49             0.56             0.29             0.27             0.53             1.00             0.53             0.35             0.30 
            0.30             0.34             0.34             0.38             0.29             0.35             0.53             1.00             0.43             0.40 
            0.43             0.39             0.48             0.10             0.38             0.41             0.35             0.43             1.00             0.20 
            0.03             0.07             0.06             0.63             0.09             0.07             0.30             0.40             0.20             1.00 ;
mu = mu/100;
sigma = sigma/100;
cov1 = eye(10) .* sigma .* sigma';
cov2 = rho .* sigma .* sigma';

A = ones(1,10); B = 0; C = 0; D = 0; Bounds = (-10~10) .* ones(10,1);

{x1,mu1,sigma1,phi1,retcode1} = Qprog_Allocation_Solve(mu,cov1,A,B,C,D,Bounds,0.03,2);
print ftosa(reshape(x1,2,5),"%lf",3,3);
{x2,mu2,sigma2,phi2,retcode2} = Qprog_Allocation_Solve(mu,cov2,A,B,C,D,Bounds,0.03,2);
print ftosa(reshape(x2,2,5),"%lf",3,3);
print ftosa(100*mu2,"carry = %lf",3,3);
PnL = sumc(x2 .* mu)/3;
print ftosa(PnL,"PnL = %lf",3,6);
{x3,mu3,sigma3,phi3,retcode3} = Qprog_Allocation_Solve(mu,cov2,A,B,C,D,Bounds,0.05,2);
print ftosa(reshape(x3,2,5),"%lf",3,3);
Leverage = sumc(abs(x1))|sumc(abs(x2))|sumc(abs(x3));
print ftosa(Leverage,"%lf",3,2);
