
new;
library qam,pgraph,optmum;

rndseed 123456;

__output = 0;

cls;

// Question 1

let beta = 0.7  0.9  1.1 1.3  1.5;
let w1   = 0.5  0.5  0.0 0.0  0.0;
let w2   = 0.25 0.25 0.5 0.5 -0.5;

beta1 = w1'beta;
beta2 = w2'beta;
print ftos(beta1,"beta1 = %lf",3,3);
print ftos(beta2,"beta2 = %lf",3,3);
print "---------------------------";

// Question 2

let rho = 1.0
          0.5 1.0
          0.5 0.5 1.0;
rho = xpnd(rho);
let b = 0.4 0.3 0.3;
let beta = 0.811 0.998 1.254;
let beta_ew = 1.021;

proc func1(x);
  local cov,u;

  x = sqrt(x^2);
  cov = rho .* x' .* x;
  u = (cov*b) / (b'cov*b) - beta;
  retp(u'u);
endp;

let sv = 0.20 0.20 0.20;
{x,fmin,grd,retcode} = optmum(&func1,sv);
x1 = x;

let sv = 0.10 0.10 0.10;
{x,fmin,grd,retcode} = optmum(&func1,sv);
x2 = x;

x = x1;
x = sqrt(x^2);
cov = rho .* x' .* x;
beta_x = (cov*b) / (b'cov*b);
w_ew = ones(3,1)/3;
beta_x = beta_x | (w_ew'cov*b) / (b'cov*b);
x = x | miss(0,0);
print ftosa(100*x~x./x[1]~beta_x,"%lf",3,3);
print "---------------------------";
x = x2;
x = sqrt(x^2);
cov = rho .* x' .* x;
beta_x = (cov*b) / (b'cov*b);
beta_x = beta_x | (w_ew'cov*b) / (b'cov*b);
x = x | miss(0,0);
print ftosa(100*x~x./x[1]~beta_x,"%lf",3,3);
print "---------------------------";
let x = 0.20 0.25 0.30;
x = sqrt(x^2);
cov = rho .* x' .* x;
beta_x = (cov*b) / (b'cov*b);
beta_x = beta_x | (w_ew'cov*b) / (b'cov*b);
x = x | miss(0,0);
print ftosa(100*x~x./x[1]~beta_x,"%lf",3,3);
print "---------------------------";

proc func2(x);
  local cov,u1,w_ew,u2,u;

  x = sqrt(x^2);
  cov = rho .* x' .* x;
  u1 = (cov*b) / (b'cov*b) - beta;
  w_ew = ones(3,1)/3;
  u2 = (w_ew'cov*b) / (b'cov*b) - beta_ew;
  u = u1|u2;
  retp(u'u);
endp;

let x = 0.20 0.25 0.30;
{x,fmin,grd,retcode} = optmum(&func2,x);
x = sqrt(x^2);
cov = rho .* x' .* x;
beta_x = (cov*b) / (b'cov*b);
w_ew = ones(3,1)/3;
beta_x = beta_x | (w_ew'cov*b) / (b'cov*b);
x = x | miss(0,0);

print ftosa(100*x~x./x[1]~beta_x,"%lf",3,3);
print "---------------------------";

// Question 3
let sigma = 0.20 0.25 0.30;
let rho = 1.0
          0.5 1.0
          0.5 0.5 1.0;
rho = xpnd(rho);
cov = rho .* sigma' .* sigma;
b = ones(3,1)/3;
beta1 = (cov*b)/(b'*cov*b);

let sigma = 0.30 0.25 0.20;
let rho = 1.0
          -0.2 1.0
          -0.2 -0.2 1.0;
rho = xpnd(rho);
cov = rho .* sigma' .* sigma;
b = ones(3,1)/3;
beta2 = (cov*b)/(b'*cov*b);
print ftosa(beta1~beta2,"%lf",3,3);
print "---------------------------";

let sigma = 0.15 0.20 0.22;
let rho = 1.0
          0.7  1.0
          0.2 -0.5 1.0;
rho = xpnd(rho);
call invpd(rho);
cov = rho .* sigma' .* sigma;
b = ones(3,1)/3;
beta = (cov*b)/(b'*cov*b);
print ftosa(sigma~beta,"%lf",3,3);
print "---------------------------";

let b = 0.05 0.25 0.70;
beta1 = (cov*b)/(b'*cov*b);
let b = 0.20 0.40 0.40;
beta2 = (cov*b)/(b'*cov*b);
print ftosa(sumc(beta1)~sumc(beta2),"%lf",3,3);
print "---------------------------";

// Question 4


let R_M =  -0.26            -0.09            -0.10            -0.10             0.16             0.14 
            0.14             0.15            -0.22            -0.07            -0.11             0.02 
            0.15            -0.15            -0.01            -0.23             0.15            -0.06; 

let R_i =  -0.22            -0.11            -0.10            -0.08             0.13             0.11 
            0.21             0.13            -0.30            -0.06            -0.05            -0.05 
            0.19            -0.17             0.02            -0.24             0.25            -0.07; 

y = R_i;
x = R_M;
beta_hat = y/x;
u = y - x*beta_hat;
std_y = stdc(y);
std_x = stdc(x);
std_u = stdc(u);

print ftos(beta_hat,"beta_i = %lf",3,5);
print ftos(std_y^2,"var_i = %lf",3,5);
print ftos(std_x^2,"var_M = %lf",3,5);
print ftos(beta_hat^2*std_x^2+std_u^2,"var_i = %lf",3,5);
print ftos((beta_hat^2*std_x^2)/(std_y^2),"ctr_M = %lf",3,5);

