new;
library qam,pgraph,optmum;

cls;

rndseed 123;

n = 4;

r = 0.05;
mu = r + rndu(n,1)*0.10;
sigma = rndu(n,1) * 0.30;
sh = (mu - r)./sigma;

print ftosa(mu~sigma~sh,"%lf",3,3);

rho = 0;
rho = diagrv(rho*ones(n,n),1);
cov = rho .* sigma .* sigma';
w = ones(n,1)/n;

sh1 = (w'mu - r)/sqrt(w'*cov*w);
sh2 = sumc(mu - r)/sqrt(sumc(sigma^2));
p = sigma/sqrt(sumc(sigma^2));
sh3 = p'*sh;
print sh1~sh2~sh3;

let sigma = 0.20 0.20 0.30 0.10 0.30;
let sh =    0.40 0.35 0.30 0.70 0.40;
p1 = sigma/sqrt(sumc(sigma^2));
sh1 = p1'sh;

let sigma = 0.15 0.15 0.20 0.10 0.50;
let sh =    0.10 0.15 0.05 0.05 0.90;
p2 = sigma/sqrt(sumc(sigma^2));
sh2 = p2'sh;

print ftosa(100*((p1'~sumc(p1)~sh1)|(p2'~sumc(p2)~sh2)),"%lf",3,1);

let sigma = 0.50 2.00;
let sh =    0.50 0.40;
p3 = sigma/sqrt(sumc(sigma^2));
sh3 = p3'sh;
print sh3;

rndseed 123;

n = 10;

r = 0.05;
mu = r + rndu(n,1)*0.10;
sigma = ones(n,1) * 0.30;
sh = (mu - r)./sigma;

print ftosa(mu~sigma~sh,"%lf",3,3);

rho = 0.5;
cor = diagrv(rho*ones(n,n),1);
cov = cor .* sigma .* sigma';
w = ones(n,1)/n;

vol1 = sqrt(w'*cov*w);
sh1 = w'(mu - r)/vol1;
vol2 = sigma[1]*sqrt(rho + (1 - rho)/n);
sh2 = (sigma[1]*sumc(sh)/n)/vol2;

p = (1/sqrt(rho + (1 - rho)/n));
sh3 = p*meanc(sh);

print sh1~sh2~sh3;

rho = 0.50;
n = 4;
p = (1/sqrt(rho + (1 - rho)/n));
print p;

p = 1.25;
n = (p^2)*(1 - rho)/(1 - rho * p^2);
print n;

rho = 0.80;
p = 1.25;
n = (p^2)*(1 - rho)/(1 - rho * p^2);
print n;
