new;
library qam,pgraph,optmum;

cls;

let sigma = 0.15 0.15 0.05;
let mu =    0.10 0.10 0.05;
let rho = 1.00 
          0.50 1.00
          0.20 0.20 1.00;
rho = xpnd(rho);
cov = rho .* sigma .* sigma';

phi0 = 0;
sv = ones(3,1)/3;

A = ones(1,3); B = 1; C = 1~0~0; D = 0.08; Bounds = (0~1) .* ones(3,1); 
{x0,u1,u2,u3,u4,retcode0} = QProg(sv,2*cov,phi0*mu,A,B,C,D,Bounds);

print "---------------------------------------------------";
print "x0 = " x0';
print "u1 = " u1';
print "u2 = " u2';
print "u3 = " u3';
print "u4 = " u4';

Q = 2 * cov;
R = phi0 * mu;
S = -C|A|-A|-eye(3); 
T = -D|B|-B|zeros(3,1);

{x1,u1,u2,u3,u4,retcode0} = QProg(sv,Q,R,0,0,-S,-T,0);

print "---------------------------------------------------";
print "x0 = " x0';
print "u1 = " u1';
print "u2 = " u2';
print "u3 = " u3';
print "u4 = " u4';

Q_tilde = S*invpd(Q)*S';
R_tilde = S*invpd(Q)*R - T;
Bounds = (0~100) .* ones(6,1); 

{lagr,u1,u2,u3,u4,retcode0} = QProg(ones(6,1),Q_tilde,R_tilde,0,0,0,0,bounds);

print "lagr = " lagr';





