new;
library qam,optmum,pgraph;

let mu = 0.10 -0.10 0.00 0.05;
let sigma = 0.15 0.20 0.25 0.30;
let rho =   1.0
            0.5 1.0
            0.4 0.3 1.0
            0.1 0.1 0.1 1.0;

rho = xpnd(rho);
cov = rho .* sigma .* sigma';
nAssets = rows(cov);

// Question 1

{x,vol,mr,tr,rc} = Compute_ERC_Portfolio(0,cov);
results_erc = 100*(x~mr~tr~rc);

print ftosa(results_erc,"%lf",3,2);

x0 = x;
sigma_x0 = sqrt(x0'*cov*x0);
A = ones(1,nAssets); B = 1;
Bounds = ones(nAssets,1) .* (0~1);

Results_te = 100*x0|error(0)|error(0)|error(0)|100*sigma_x0|error(0);

// Question 2.a
{x,surperf,te,phi,retcode} = Qprog_TE_Solve(x0,cov,A,B,0,0,Bounds,mu,0.01);
IR = surperf/te;
sigma_x = sqrt(x'*cov*x);
rho = (x'*cov*x0)/(sigma_x * sigma_x0);
Results_te = Results_te ~ (100*x|100*(Surperf|TE)|IR|100*(sigma_x|rho));

// Question 2.b
{x,surperf,te,phi,retcode} = Qprog_TE_Solve(x0,cov,A,B,0,0,Bounds,mu,0.05);
IR = surperf/te;
sigma_x = sqrt(x'*cov*x);
rho = (x'*cov*x0)/(sigma_x * sigma_x0);
Results_te = Results_te ~ (100*x|100*(Surperf|TE)|IR|100*(sigma_x|rho));

{x,surperf,te,phi,retcode} = Qprog_TE_Solve(x0,cov,A,B,0,0,Bounds,mu,0.10);
IR = surperf/te;
sigma_x = sqrt(x'*cov*x);
rho = (x'*cov*x0)/(sigma_x * sigma_x0);
Results_te = Results_te ~ (100*x|100*(Surperf|TE)|IR|100*(sigma_x|rho));

// Question 2.c
{x,surperf,te,phi,retcode} = Qprog_TE_Solve(x0,cov,A,B,0,0,Bounds,mu,0.35);
IR = surperf/te;
sigma_x = sqrt(x'*cov*x);
rho = (x'*cov*x0)/(sigma_x * sigma_x0);
Results_te = Results_te ~ (100*x|100*(Surperf|TE)|IR|100*(sigma_x|rho));

print ftosa(results_te,"%lf",3,2);

Bounds = ones(nAssets,1) .* (-3~3);
Results_te = 100*x0|error(0)|error(0)|error(0)|100*sigma_x0|error(0);

// Question 3.a
{x,surperf,te,phi,retcode} = Qprog_TE_Solve(x0,cov,A,B,0,0,Bounds,mu,0.01);
IR = surperf/te;
sigma_x = sqrt(x'*cov*x);
rho = (x'*cov*x0)/(sigma_x * sigma_x0);
Results_te = Results_te ~ (100*x|100*(Surperf|TE)|IR|100*(sigma_x|rho));

dx1 = x - x0;

// Question 3.b
{x,surperf,te,phi,retcode} = Qprog_TE_Solve(x0,cov,A,B,0,0,Bounds,mu,0.05);
IR = surperf/te;
sigma_x = sqrt(x'*cov*x);
rho = (x'*cov*x0)/(sigma_x * sigma_x0);
Results_te = Results_te ~ (100*x|100*(Surperf|TE)|IR|100*(sigma_x|rho));

dx2 = x - x0;

{x,surperf,te,phi,retcode} = Qprog_TE_Solve(x0,cov,A,B,0,0,Bounds,mu,0.10);
IR = surperf/te;
sigma_x = sqrt(x'*cov*x);
rho = (x'*cov*x0)/(sigma_x * sigma_x0);
Results_te = Results_te ~ (100*x|100*(Surperf|TE)|IR|100*(sigma_x|rho));

dx3 = x - x0;

// Question 3.c
{x,surperf,te,phi,retcode} = Qprog_TE_Solve(x0,cov,A,B,0,0,Bounds,mu,0.35);
IR = surperf/te;
sigma_x = sqrt(x'*cov*x);
rho = (x'*cov*x0)/(sigma_x * sigma_x0);
Results_te = Results_te ~ (100*x|100*(Surperf|TE)|IR|100*(sigma_x|rho));

dx4 = x - x0;

print ftosa(results_te,"%lf",3,2);

print ftosa((dx2./dx1)~(dx3./dx1)~(dx4./dx1),"%lf",3,2);

